<?php

namespace Drupal\car_specification\Plugin\Field\FieldWidget;

use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\WidgetBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Plugin implementation of the 'car_specification_default_widget' widget.
 *
 * @FieldWidget(
 *   id = "car_specification_default_widget",
 *   label = @Translation("Car specification default widget"),
 *   field_types = {
 *     "car_specification"
 *   }
 * )
 */
class CarSpecificationDefaultWidget extends WidgetBase {

  /**
   * {@inheritdoc}
   */
  public function formElement(FieldItemListInterface $items, $delta, array $element, array &$form, FormStateInterface $form_state) {
 // Car Library
    $form['#attached']['library'][] = 'car_specification/car_specification.carselect';
    // Car Years
    $element['car_years'] = [
      '#type' => 'select',
      '#title' => t('Car Years'),
      '#name' => t('car-years'),
      '#id' => t('car-years'),
      // Set here the current value for this field, or a default value (or 
      // null) if there is no a value
      '#default_value' => isset($items[$delta]->car_years) ? 
          $items[$delta]->car_years : null,

      '#empty_value' => '',
    ];

    // Car Makes
    $element['car_makes'] = [
      '#type' => 'select',
      '#title' => t('Car Makes'),
      '#name' => t('car-makes'),
      '#id' => t('car-makes'),
      // Set here the current value for this field, or a default value (or 
      // null) if there is no a value
      '#default_value' => isset($items[$delta]->car_makes) ? 
          $items[$delta]->car_makes : null,

      '#empty_value' => '',
    ];

    // Car Models
    $element['car_models'] = [
      '#type' => 'select',
      '#title' => t('Car Models'),
      '#name' => t('car-models'),
      '#id' => t('car-models'),
      // Set here the current value for this field, or a default value (or 
      // null) if there is no a value
      '#default_value' => isset($items[$delta]->car_models) ? 
          $items[$delta]->car_models : null,

      '#empty_value' => '',
    ];

   // Car Model Trims
    $element['car_model_trims'] = [
      '#type' => 'select',
      '#title' => t('Car Model Trims'),
      '#name' => t('car-model-trims'),
      '#id' => t('car-model-trims'),
      // Set here the current value for this field, or a default value (or 
      // null) if there is no a value
      '#default_value' => isset($items[$delta]->car_model_trims) ? 
          $items[$delta]->car_model_trims : null,
      '#empty_value' => '',
      '#suffix' => '<div id="cq-show-data" class="button">Show</div>',
    ];
    return $element;
  }

}
